transformers-0.3.0.0: Concrete functor and monad transformers

Portability | portable
Stability | experimental
Maintainer | ross@soi.city.ac.uk
Safe Haskell | Safe-Inferred

Data.Functor.Compose

Description

Composition of functors.

Synopsis

- newtype Compose f g a = Compose {
  - getCompose :: f (g a)
  }

# Documentation

newtype Compose f g a Source

Right-to-left composition of functors. The composition of applicative functors is always applicative, but the composition of monads is not always a monad.

Constructors

Compose |
Fields getCompose :: f (g a)

Instances

(Functor f, Functor g) => Functor (Compose f g) |
(Applicative f, Applicative g) => Applicative (Compose f g) |
(Foldable f, Foldable g) => Foldable (Compose f g) |
(Traversable f, Traversable g) => Traversable (Compose f g) |
(Alternative f, Applicative g) => Alternative (Compose f g) |